void gameinput(){
  //speed modifiers
  double frameTime = (ftime - foldTime) / 1000.0; //frametime is the time this frame has taken, in seconds
  double moveSpeed = frameTime * 6.0; //the constant value is in squares/second
  double rotSpeed = frameTime * 3.0; //the constant value is in radians/second
  readKeys();
  //move forward if no wall in front of you
 if (keyDown(SDLK_UP))
  {
    if(worldMap[int(posX + dirX * moveSpeed)][int(posY)] == false) posX += dirX * moveSpeed;
    if(worldMap[int(posX)][int(posY + dirY * moveSpeed)] == false) posY += dirY * moveSpeed;
    set_playerpos(posX, posY, dirX, dirY);
  }
  //move backwards if no wall behind you
  if (keyDown(SDLK_DOWN))
  {
    if(worldMap[int(posX - dirX * moveSpeed)][int(posY)] == false) posX -= dirX * moveSpeed;
    if(worldMap[int(posX)][int(posY - dirY * moveSpeed)] == false) posY -= dirY * moveSpeed;
    set_playerpos(posX, posY, dirX, dirY);
  }
  //rotate to the right
  if (keyDown(SDLK_RIGHT))
  {
    //both camera direction and camera plane must be rotated
    double oldDirX = dirX;
    dirX = dirX * cos(-rotSpeed) - dirY * sin(-rotSpeed);
    dirY = oldDirX * sin(-rotSpeed) + dirY * cos(-rotSpeed);
    double oldPlaneX = planeX;
    planeX = planeX * cos(-rotSpeed) - planeY * sin(-rotSpeed);
    planeY = oldPlaneX * sin(-rotSpeed) + planeY * cos(-rotSpeed);
    set_playerpos(posX, posY, dirX, dirY);
  }
  //rotate to the left
  if (keyDown(SDLK_LEFT))
  {
    //both camera direction and camera plane must be rotated
    double oldDirX = dirX;
    dirX = dirX * cos(rotSpeed) - dirY * sin(rotSpeed);
    dirY = oldDirX * sin(rotSpeed) + dirY * cos(rotSpeed);
    double oldPlaneX = planeX;
    planeX = planeX * cos(rotSpeed) - planeY * sin(rotSpeed);
    planeY = oldPlaneX * sin(rotSpeed) + planeY * cos(rotSpeed);
    set_playerpos(posX, posY, dirX, dirY);
  }
}
